
package de.ivu.elect.presentation.kandidatur.action;

import javax.annotation.Nonnull;

import de.ivu.elect.business.kandidatur.entity.Ersatzkandidatur;
import de.ivu.elect.business.kandidatur.entity.Kandidatur;
import de.ivu.elect.business.kandidatur.entity.KandidaturStatus;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.wahl.CurrentWahlZulassungspruefungExtended;

public class ErsatzkandidaturZulassungAufhebenKeineZulassungsfaehigkeitNachZulassungsausschussAction extends AbstractErsatzkandidaturZulassungAction {

  private static final long serialVersionUID = 1L;

  public ErsatzkandidaturZulassungAufhebenKeineZulassungsfaehigkeitNachZulassungsausschussAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLVORSCHLAG_QS_ZULASSUNG_AENDERN_NACHTRAEGLICH_KEINE_ZULASSUNGSFAEHIGKEIT_NACH_ZULASSUNGSAUSSCHUSS;
  }

  @Override
  public boolean isDisabledInternal(Ersatzkandidatur ersatzkandidatur, CurrentWahlZulassungspruefungExtended currentWahlZulassungspruefung) {
    return !currentWahlZulassungspruefung.isZulassungAufhebenKeineZulassungsfaehigkeitNachZulassungsausschussZulaessig(ersatzkandidatur);
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Kandidatur kandidatur) {
    return super.isDisabledInternal(kandidatur) || !kandidatur.isZugelassen();
  }

  @Override
  protected KandidaturStatus getKandidaturStatus() {
    return KandidaturStatus.NICHT_MEHR_ZUGELASSEN_WEIL_ZULASSUNGSFAEHIGKEIT_NACH_ZULASSUNGSAUSSCHUSS_VERLOREN;
  }

  @Override
  public String getLabelKey() {
    return "kandidatur.search.action.nicht.zulassen.da.zulassungsfaehigkeit.nach.zulassungsausschuss.verloren";
  }
}
